#include <stdio.h>
#include <EzGraph.h>
#include "config.h"
#include "main.h"
#include "layout.h"
#include "select_stage.h"
#include "select_stage_draw.h"
#include "stage.h"

static char *stage_names[]
= {
   "test",
    "tutorial1",
    "pots",
   "ladder",
   "box",
   "maze",
   "sample1",
   "sample2",
   "sample3",
   "sample4",
   

#ifdef DEBUG
#endif
 };

#define STAGE_NUM (sizeof(stage_names)/sizeof(char*))

static stage_thumb_t stage_thumbs[STAGE_NUM];
static stage_thumb_t *current_stage_thumb = NULL;

static int stage_num = STAGE_NUM;

static int cursor_x, cursor_y, line;
static int line_num;



void select_stage_init(void){
    int i;

    for (i = 0 ; i < stage_num ; i++){
        printf("gen thumb:%s\n", get_stage_name(i));
        get_thumb(get_stage_name(i), &stage_thumbs[i], i+1);
        //        total_score += stage_thumbs[i].top_score;
        //        if (stage_thumbs[i].top_score > 0) cleared_stage_num ++;
    }
    line = 0;
	cursor_x = 0;
	cursor_y = 0;
    line_num = (stage_num-1) / THUMB_COL_NUM + 1;
    printf("thumb line_num = %d\n", line_num);
    update_thumbs_info();
}

void setup_select_stage(void){
    EzSetKeyHandler(select_stage_keyh);
    EzSetKeyReleaseHandler(select_stage_key_releaseh);
    EzSetTimerHandler(select_stage_timerh, GAME_SPEED);
    //    update_thumbs_info();
}

void select_stage_keyh(int key){
    //    printf("line=%d/%d, (%d,%d)", line, line_num, cursor_x, cursor_y);

    switch (key){
    case EZ_Left:
        cursor_x = (cursor_x + THUMB_COL_NUM - 1) % THUMB_COL_NUM;
        break;
    case EZ_Right:
        cursor_x = (cursor_x + 1) % THUMB_COL_NUM;
        break;
    case EZ_Up:
        if (cursor_y == 0){
            if (line > 0){
                line --;
            }
            else {
                line = line_num-THUMB_ROW_NUM;
                cursor_y = THUMB_ROW_NUM-1;
            }
        }
        else {
            cursor_y --;
        }
        break;
    case EZ_Down:
        if (cursor_y == THUMB_ROW_NUM-1){
            if (line < line_num-THUMB_ROW_NUM){
                line ++;
            }
            else {
                line = 0;
                cursor_y = 0;
            }
        }
        else {
            cursor_y ++;
        }
        break;
    default:
        break;
    }
    printf(" -> %d/%d, (%d,%d)\n", line, line_num, cursor_x, cursor_y);
}

void select_stage_key_releaseh(int key){
    int si;
    switch (key){
    case ' ':
    case EZ_Return:
        si = CursorPos2StageIx(cursor_x, cursor_y, line);
        if (si < stage_num){
			current_stage_thumb = &stage_thumbs[si];
            load_stage(get_stage_name(si));
            set_main_state(ms_game);
        }
        break;
    case 'q':
	case 27:
        set_main_state(ms_title);
		break;
    default:
        break;
    }
}

void select_stage_timerh(void){
    draw_select_stage(stage_thumbs, stage_num, cursor_x, cursor_y, line);
}

char *get_stage_name(int n){
    return stage_names[n];
}


unsigned int get_current_stage_no(void){
    return CursorPos2StageIx(cursor_x, cursor_y, line) + 1;
}

stage_thumb_t *get_current_thumb(void){
	return current_stage_thumb;
}

unsigned int get_cleared_stage_num(void){
    return 0;
    //    return cleared_stage_num;
}
unsigned int get_stage_num(void){
    return 0;
    //    return stage_num;
}
// サムネイル一覧表示用の情報を、最新のものに更新する
void update_thumbs_info(void){
}

